import { MessageFlags } from "discord.js"
import type { ButtonInteraction } from "discord.js"
import { generateTwitchEmbed } from "@/utils/twitch"
import type { GuildTwitch } from "@/types/schemas"
import dbGuild from "@/schemas/guild"
import { t } from "@/utils/i18n"

export const id = "twitch_enable"
export async function execute(interaction: ButtonInteraction) {
	const guildProfile = await dbGuild.findOne({ guildId: interaction.guild?.id })
	if (!guildProfile) return interaction.reply({ content: t(interaction.locale, "common.database_not_found"), flags: MessageFlags.Ephemeral })

	const dbData = guildProfile.get("guildTwitch") as GuildTwitch
	dbData.enabled = true
	dbData.botId = interaction.client.user.id

	guildProfile.set("guildTwitch", dbData)
	guildProfile.markModified("guildTwitch")
	await guildProfile.save().catch(console.error)

	// Utiliser la fonction utilitaire pour générer l'embed et les composants mis à jour
	const { embed, components } = generateTwitchEmbed(dbData, interaction.client, interaction.guild?.id ?? "", interaction.locale)

	return interaction.update({
		embeds: [embed],
		components: components
	})
}
